﻿@model StarterProjectV2.ViewModels.DividendViewModel


@{
    ViewBag.Title = "Add Dividends For All Owners";
}



@section HEADERJS{
    <script type="text/javascript" src="https://cdn.jsdelivr.net/jquery/2.0.2/jquery.min.js"></script>
    <style>
        .card-body {
            padding: 60px
        }

        #load_screen {
            position: fixed;
            top: 0;
            opacity: 1;
            width: 100%;
            height: 100vh;
            z-index: 10;
            display: flex;
            justify-content: center;
            align-items: center;
            background: white;
        }

        @@keyframes rotate {
            0% {
                transform: rotate(360deg);
            }
        }

        @@keyframes wink {
            50% {
                opacity: 0;
            }
        }

        .spinner {
            width: 7em;
            margin: 3em auto;
            position: relative;
        }

            .spinner:before {
                content: "";
                display: block;
                width: 6em;
                height: 1em;
                margin: 3em auto;
                padding: 3em 0;
                border-radius: 50%;
                border: 2px dotted #2f416f;
                border-top: 2px solid transparent;
                border-bottom: 2px solid transparent;
                animation: rotate 1s ease infinite;
            }

            .spinner:after {
                content: "loading..";
                position: absolute;
                top: 40px;
                color: #2f416f;
                font: .9em sans-serif;
                width: 8em;
                line-height: 8em;
                text-align: center;
                animation: wink 1.4s ease infinite;
            }
    </style>
}
@section FOOTERJS{

    <script src="~/Content/vendors/js/coreui.min.js"></script>
    <script src="~/Content/vendors/js/toastr.min.js"></script>
}
@section PAGETITLE{
    Add Dividends For All Owners
}
    <body style="background-color: oldlace">
        <h2 class="text-center mt-4" style="color:indianred">@ViewData["Title"]</h2>
        <div class="card">
            <div class="alert alert-danger alert-dismissible fade show" id="alert-box" style="display: none" role="alert">
                <strong>Please, fill up all the information correctly ,or select a valid file.</strong> Click the cross button to dismiss the message.
                <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="card-body">

                @using (Html.BeginForm("DividendDistributionForAllOwners", "Dividend", FormMethod.Post, new { enctype = "multipart/form-data" }))
                {
                    <div class="mb-3 form-group row mb-3">

                        @Html.HiddenFor(m => m.fromMonth, new { @id = "from-month" })
                        @* </div> *@
                        <label class="col-lg-2 col-md-2 col-sm-2 col-form-label" for="text-input">Financial Year</label>
                        <div class="col-sm-4 col-lg-4 col-md-4">
                            @Html.DropDownListFor(m => m.selectFinancialId, @Model.FinancialIdandParent.Select(m => new SelectListItem()
                            {
                                Text = m.Year,
                                Value = m.FinId
                            }), new { @class = "form-control", id = "sel1" })
                        </div>
                        <label class="col-sm-2 col-lg-2 col-md-3  col-form-label">Dividend Maturity Month</label>
                        <div class="col-sm-4 col-lg-4 col-md-4">
                            @Html.TextBoxFor(m => m.toMonth, new { @class = "form-control", placeholder = "Month", id = "dividend-mat-month", name = "text-input", type = "month", @onchange = "checkingFinancialYear();" })

                        </div>
                    </div>

                    <div class="form-group row mb-3">
                        <label class="col-sm-2 col-lg-2 col-md-2  col-form-label">Dividend Amount of Given Time Period</label>
                        <div class="col-sm-4 col-lg-4 col-md-4">
                            @Html.TextBoxFor(m => m.divAmount, new { @class = "form-control", placeholder = "Amount", id = "div-amnt", name = "text-input", type = "number" })

                        </div>
                        <label class="col-sm-4 col-lg-2 col-md-4  col-form-label">Per Sq Feet Dividend Amount</label>
                        <div class="col-sm-4 col-lg-4col-md-4">
                            @Html.TextBoxFor(m => m.divAmountPerSq, new { @class = "form-control", placeholder = "Per Sq Feet Dividend Amount", id = "div-amnt-per-sq-ft", name = "text-input", type = "number", @readonly = "f" })

                        </div>
                    </div>

                    <div class="form-group row mb-3">
                        <label class="col-sm-2 col-lg-2 col-md-2  col-form-label">Total Hotel Size @*sold to owners*@ (in square feet)</label>
                        <div class="col-sm-4 col-lg-4 col-md-4">
                            @*@Html.TextBoxFor(m => m.totalHotelSize, new { @class = "form-control", placeholder = "Total Size", id = "div-totalsz", name = "text-input", type = "number" })*@
                            @Html.Raw(Model.totalSqFeet)
                        </div>

                    </div>
                    <hr />
                    <div class="form-check mb-2">
                        <input class="form-check-input" type="checkbox" value="" id="defaultCheck" onclick="enableButton()">
                        <label class="form-check-label" for="defaultCheck1">
                            <span style="font-weight: bold">I am aware that by submitting the form, all the owners' dividend will be updated during the given time period. Click the Check button to enable submit.</span>
                        </label>
                    </div>
                    <button type="submit" disabled="disabled" value="Upload" id="submit" class="btn btn-danger " onclick="loadScreen()">Submit</button>
                }

            </div>

        </div>
    <div id="load_screen" style="display:none">
        <div class="spinner"></div>
    </div>
    </body>
        <script>
            function enableButton() {
                if (document.getElementById("defaultCheck").checked == true) {
                    document.getElementById("submit").disabled = false;
                } else {
                    document.getElementById("submit").disabled = true;
                }
            }
        </script>
        <script>
            //    document.getElementById("load_screen").style.display = "flex";
            function loadScreen() {
                //alert("ehihf");
                document.getElementById("load_screen").style.display = "flex";
            }
        </script>
        <script>
            $('#sel1').change(function () {
                document.getElementById("dividend-mat-month").value = '';
                document.getElementById("from-month").value = '';
            });
        </script>
        <script>
            function checkingFinancialYear() {

                var myModel = {
                    finId: $('#sel1').val(),
                    dividendMaturityMonth: $('#dividend-mat-month').val()
                };
                $.ajax({
                    context: this,
                    type: 'post',
                    url: '/Dividend/checkingDividendMaturityMonth/',
                    data: myModel,
                    success: function (result) {
                        var monthArray = ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'];
                        if (result.isAlreadyExists === 'y' && result.FixedToMonth != '') {
                            var dividendMaturityMonthDate = new Date(result.FixedToMonth);
                            //alert(dividendMaturityMonthDate);
                            var dd = String(dividendMaturityMonthDate.getDate()).padStart(2, '0');
                            var mm = String(dividendMaturityMonthDate.getMonth() + 1).padStart(2, '0'); //January is 0!
                            var yyyy = dividendMaturityMonthDate.getFullYear();
                            var yyyyMaturity = yyyy;
                            var dividendMaturityMonthDateJs = yyyy + "-" + mm;
                            //alert(dividendMaturityMonthDateJs);
                            var fromMonthDate = new Date(result.FixedFromMonth);
                            //alert(dividendMaturityMonthDate);
                            var dd = String(fromMonthDate.getDate()).padStart(2, '0');
                            var mm = String(fromMonthDate.getMonth() + 1).padStart(2, '0'); //January is 0!
                            var yyyy = fromMonthDate.getFullYear();
                            var fromMonthDateJs = yyyy + "-" + mm;
                            document.getElementById("dividend-mat-month").value = dividendMaturityMonthDateJs;
                            document.getElementById("from-month").value = fromMonthDateJs;
                            document.getElementById("dividend-mat-month").style.borderColor = "#FF0000";

                            var fromMonth = monthArray[fromMonthDate.getMonth()] + "-" + yyyy;
                            var toMonthDate = monthArray[dividendMaturityMonthDate.getMonth()] + "-" + yyyyMaturity;

                            toastr.error('Your selected month does not match the given financial year range. So, the dividend maturity month has been changed to comply with the available dividend start month. As a result, the starting dividend month is ' + fromMonth + ' and the dividend maturity month has been changed to ' + toMonthDate + '. Please, select any month including and after the given dividend maturity month. Also, click the cross button to close the message.', 'Error!!!!', {
                                closeButton: true,
                                extendedTimeOut: 0,
                                timeOut: 0,
                            });
                        } else if (result.isAlreadyExists === 'y' && result.FixedToMonth === '') {
                            document.getElementById("dividend-mat-month").value = '';
                            document.getElementById("from-month").value = '';
                            document.getElementById("dividend-mat-month").style.borderColor = "#FF0000";
                            toastr.error('You cannot upload any data in the selected financial year as all the year\'s data has been uploaded. Please, select a different financial year. Also, click the cross button to close the message.', 'Error!!!!', {
                                closeButton: true,
                                extendedTimeOut: 0,
                                timeOut: 0,
                            });
                        } else if (result.isAlreadyExists === 'n') {
                            var fromMonthDate = new Date(result.FixedFromMonth);
                            //alert(dividendMaturityMonthDate);
                            //alert(result.isAlreadyExists + ' ' + result.FixedFromMonth + ' ' + result.FixedToMonth);
                            var dd = String(fromMonthDate.getDate()).padStart(2, '0');
                            var mm = String(fromMonthDate.getMonth() + 1).padStart(2, '0'); //January is 0!
                            var yyyy = fromMonthDate.getFullYear();
                            var fromMonthDateJs = yyyy + "-" + mm;
                            document.getElementById("dividend-mat-month").style.borderColor = "#008000";
                            document.getElementById("from-month").value = fromMonthDateJs;
                            var fromMonth = monthArray[fromMonthDate.getMonth()] + "-" + yyyy;
                            //alert(fromMonthDate + ' ' + fromMonth);
                            var toMonthDate = new Date(result.FixedToMonth);
                            var mm = String(toMonthDate.getMonth() + 1).padStart(2, '0'); //January is 0!
                            var yyyy = toMonthDate.getFullYear();
                            var toMonthDateJs = yyyy + "-" + mm;
                            var toMonthDate = monthArray[toMonthDate.getMonth()] + "-" + yyyy;

                            toastr.success('The available dividend start month for the selected financial year is ' + fromMonth + ' and the selected dividend maturity month is ' + toMonthDate + '. Also, click the cross button to close the message.', 'Success!!!!', {
                                closeButton: true,
                                extendedTimeOut: 0,
                                timeOut: 0,
                            });
                        }
                    },
                    error: function () {
                    },
                });
                //alert('ff')
            }
        </script>

        <script>
    var flg = "@Model.flg";
    if (flg.length == 4) {
        document.getElementById("alert-box").style.display = "block";
    }
        </script>

        <script>
    var sq_feet = @Model.totalSqFeet;
    $("#div-amnt").keyup(function () {
        var div_amount = parseInt($("#div-amnt").val());
        $("#div-amnt-per-sq-ft").val(div_amount / sq_feet);
    });
        </script>

        <script>
            $(function () {
                $('[data-toggle="tooltip"]').tooltip()
            })
        </script>
        <script>
            $(document).ready(function () {
                $("#newItem").remove();
                $("#editItem").remove();
                $("#saveItem").remove();
                $("#deleteItem").remove();
                $('#printItem').click(function () {
                    window.print();
                });

                $('#reloadItem').click(function () {
                    location.reload();
                });

                $("#dashboardItem").click(function () {
                });


                $("#approve-all").click(function () {
                    $("#approve-all-confirmation").modal('toggle');
                });

            });


        </script>

        <script src="~/Content/vendors/js/jquery.min.js"></script>
        <script src="~/Content/vendors/js/popper.min.js"></script>
        <script src="~/Content/vendors/js/bootstrap.min.js"></script>
        <script src="~/Content/vendors/js/pace.min.js"></script>
        <script src="~/Content/vendors/js/toastr.min.js"></script>
        <script src="~/Content/vendors/js/perfect-scrollbar.min.js"></script>
        <script src="~/Content/vendors/js/coreui.min.js"></script>

